pro plotcar

;===============================================================================
; This routine plots variables of CARAIB versus time :
;    - climatic variables: tem, dte, prc, shr, rhu, wnd
;    - hydrological cycle variables: sw, aet, pet, alb,
;    - monthly productivity or LAI: gppmth, nppmth, nepmth, laimth 
;    - npp (species) 
;===============================================================================
; default values
; iwfrac
iwfrac=0
name_graph=''
imv=0

;===============================================================================
; npix = number of pixels in file
  npix = long(1859)

  
; nsim = number of simulations/pixels/zones to be plotted
 nsim=1
 
; multi_graph = 0 all simulations on the same graphic
; multi_graph = 1 different simulations on different graphics
multi_graph = 0 

; missing values in files
; imv : flag to consider missing values or not 
;       imv = 0 no missing values in files
;       imv = 1 missing data in the files are indicated by a prescribed numerical value (e.g., -999)
;               This value is stored in the variable mis_val and replaced by the value stored in rep_mv
; mis_val : value indicating missing data in input files
; rep_val : value used to replace missing data when means or sums are performed
; num_mv  : number of missing values found in a file
; err_mv  : error tolerated on mis_val
 
imv = 0 
mis_val = -999
rep_val = 0.
num_mv = 0
err_mv = 1
  
; plot validation data (0=no, 1=yes)
idata = 0

; file with validation data
filedata='./yield_winter_wheat_Belgium.dat'
ndata = 18
psymd = -2
legend_data = 'Yield statistics (Statbel, 2013)'
 

; size of characters for the plot
c_size=3    ;2

; size of characters for the legend
l_size=2.5    ;1.6
  
; defining color scale
color_plotcar1,r,g,b 

; defining symbols (psym) for plots
psymc=0

; plot output variable as ascii file
ifout=0

;plot line thickness
lthk=6

; range of value for x axis
; i_xrange 
i_xrange = 1
xmin = 1990.   ;1900.  
xmax = 2010.   ;1960.   

; range of value for y axis
; i_yrange 
i_yrange = 1
ymin = 0. ; 0  ;-1. ; 2000. ;0.7  ;0.  ;300.  ;0. 
ymax = 2000. ; 3500.  ;6  ;1. ;5000. ;1.2 ;25. ;70. ;140. ;400.  ;70. 

; parameter for the legend (in units of x and y variables, e.g., years and g C m-2 for NPP graph)
; i2column : legend with 2 columns - i2column = 0 : one column, i2column = 1 : two columns,  
; xleg, yleg : coordinates of the upper left corner of the legend
; dxleg = width of the legend line plot
; dyleg = distance between two lines of the legend
; 
 i2column = 1 
 xleg = xmin+(xmax-xmin)/30.
 dxleg = (xmax-xmin)/15.
 yleg = ymin+(ymax-ymin)*0.94 
 dyleg = (ymax-ymin)/20.
;  yleg = ymin+(ymax-ymin)*0.83
; dyleg = -(ymax-ymin)/20.
 
; Parameters defining the simulations
; genpath = general directory where all data are found  
; genpath = '/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/clim/Wallonia/COSMO_lprtqv/'   ;climate
; genpath = '/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/results/Wallonia/'              ;results
  genpath = '/raid3/umccb/clim0017/stughilain/caraib/results/Belgium/MAR/CRU/'    ;results
;  genpath = '/work0/umccb/verma/LAI-MODIS/'
;  genpath = '/work0/umccb/verma/MODIS_GPP/'  

dirmod = ['','','','','','','','','','','','','','','','','','','','']

;diract = ['COSMO_lprtqv_varc_TRY9_CILU5_PT6_N2_TOL2_noCO2/','COSMO_lprtqv_varc_TRY9_CILU5_PT6_N2_TOL2_noLU/','COSMO_lprtqv_varc_TRY9_CILU5_PT6_N2_TOL2/','','','','','','','']
 diract = ['','','','','','','','','','','','','','','','','','','','']

;dirfut = ['COSMO_lprtqv_varc_TRY6_noCO2/','COSMO_lprtqv_varc_TRY6_noLU/','COSMO_lprtqv_varc_TRY6/','','','','','','','']
;dirfut = ['COSMO_lprtqv_varc_TRY6_noCO2/','COSMO_lprtqv_varc_TRY6_noCO2/','COSMO_lprtqv_varc_TRY6_noCO2/','COSMO_lprtqv_varc_TRY6_noCO2/','','','','','','']
 dirfut = ['','','','','','','','','','','','','','','','','','','','']
 
 extact = ['','','','','','','','','','','','','','','','','','','','']
; extact = ['GSWP3_','GSWP3_','GSWP3_','GSWP3_','GSWP3_','GSWP3_','GSWP3_','GSWP3_','GSWP3_','GSWP3_']

 extfut = ['','','','','','','','','','','','','','','','','','','','']
; extfut = ['','GSWP3_','','GSWP3_','','GSWP3_','','GSWP3_','','GSWP3_']
; ...............................................................................................................
; parameters for defining the pixel(s) or region(s) for the plots
; use one of the 3 possibilities below (ispat_mean = 0, 1 or 2)
 
; longitudes, latitudes of pixels to be plotted (ispat_mean = 0)
 lg_pix = [ 5.997       , 5.997       , 5.997       , 5.997       ,3.7211     ,5.0869      ,5.7512,   6.2756,   6.0875,  5.6240,   5.3791]
 lt_pix = [ 50.306      ,50.306       ,50.306       ,50.306       ,50.4095    ,50.1505     ,49.7768,  50.4178, 50.2765, 50.2158,  50.0443]
; lg_pix = [ 3.7211     ,3.7211     ,5.0869      ,5.0869      ,5.7512     ,5.7512    ,6.2756     ,6.2756    ,6.0875    ,6.0875 ]
; lt_pix = [ 50.4095    ,50.4095    ,50.1505     ,50.1505     ,49.7768    ,49.7768   ,50.4178    ,50.4178   ,50.2765   ,50.2765] 
;lg_pix = [-44.7,  -44.7 ,5.9968,5.9968]
;lt_pix = [-22.5,  -22.37,50.3055,50.3055]

; min/max longitudes, min/max latitudes defining a (rectangular) region to be plotted (ispat_mean=1)
 lg_min = [2.4,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,  5.7     ,  5.7      ,  5.7,  5.7,  -180.     ,-180.      ,-180.,  -180.]
 lg_max = [6.4,7.0,7.0,7.0,7.0,7.0,7.0,7.0,7.0,7.0,  6.6     ,  6.6      , 6.6,   6.6,   180.     , 180.      , 180.,   180.]
 lt_min = [49.4,49.0,49.0,49.0,49.0,49.0,49.0,49.0,49.0,49.0, 49.5     , 49.5      , 49.5, 49.5,   -90.     , -90.      , -90.,   -90.]
 lt_max = [51.5,52.0,52.0,52.0,52.0,52.0,52.0,52.0,52.0,52.0, 49.7     , 49.7      , 49.7, 49.7 ,    90.     ,  90.      ,  90. ,   90.]
 
; regions to be plotted defined in a file (ispat_mean=2)
; This file should contain exactely the same number of lines (pixels) as other CARAIB files (ecotxt, result files)
; in the same order. It should contain the following columns: 
;     pixel number, pixel longitude, pixel latitude, pixel area (m2), region number 
; Longitude, latitudes are used just for checking that the pixels are the same as in other CARAIB files
; region number must correspond to the number defined in ireg (subsequent plots for different regions)
; pixel number and pixel area are not used, but must be present in the file for the read
; name_reg = allows to give a name to the regions. This name can be used for labelling the plots in legend_sim_v 
;Morocco
; filereg='./zone_agro_maroc.dat' 
; ireg=[1,2,3,4,5,6]
; name_reg=['Favorable','Intermediaire','Defavorable sud','Defavorable oriental','Montagne','Saharien']

;Wallonia
; filereg='../clim/Wallonia/agrizone_wal.dat'
; ireg=[3,5,6,7,8,9,10,11,12,13,14]     ; Wallonia
; name_reg=['R. Sablonneuse','R. Sablo-Limoneuse','R. Limoneuse','Campine Hennuyere','Condroz','R. Herbagere-Liegeoise','R. Herbagere des Fagnes','Famenne','Ardenne','R. Jurassique','Haute Ardenne'] 
;ireg=[12,12,12,12,12,12,12,12,12,12,12]
;Belgium
; ireg=[1,2,3,4,5,6,7,8,9,10,11,12,13,14]     ;Belgium
;name_reg=['Dunes','Polders','R. Sablonneuse','Campine','R. Sablo-Limoneuse','R. Limoneuse','Campine Hennuyere','Condroz','R. Herbagere-Liegeoise','R. Herbagere des Fagnes','Famenne','Ardenne','R. Jurassique','Haute Ardenne']

name_reg=['EC_Vielsalm','EC_Vielsalm','EC_Vielsalm','EC_Vielsalm','Quievrain','Villers-sur-Lesse','Attert','Butgenbach','Saint-Vith','Dochamps','Saint-Hubert']
;name_reg=['COSMO Quievrain','GSWP3 Quievrain','COSMO Villers-sur-Lesse','GSWP3 Villers-sur-Lesse','COSMO Attert','GSWP3 Attert','COSMO Butgenbach','GSWP3 Butgenbach','COSMO Saint-Vith','GSWP3 Saint-Vith','']

;................................................................................................................. 
 
 ; color_sim  = [1,1,2,2,3,3,4,4,5,5,6,7,8,9,10,11,12]
 color_sim  = [1,2,3,4,5,6,7,8,9,10,11,12]
 linest_sim = [0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0, 0, 0]

;  legend_sim_v = ['GPP','NPP','Ra','Rh']
;  legend_sim_v = ['NEP','NBP'] 
; legend_sim_v = ['NPP','Rh'] 
legend_sim_v = ['','','','','','','','','','','','','','','','']
;legend_sim_v = ['Fixed CO!i2!n after 1985','No LUC after 1985','All drivers: climate, LUC and CO!i2!n']
;legend_sim_v = ['Southern Area','Northern Area','Biomass_CRU_Ingrid']
;legend_sim_v = ['COSMO_lprtqv_varc_TRY9_CILU5_PT6_N2_TOL2/','TRY8_CILU5','TRY6']
;legend_sim_v = name_reg


; nmod = name of model or data
;  nmod = ': Fixed CO!i2!n after 1985' 
;  nmod=' (mean per agricultural region)'
;  nmod=' (per agricultural region)'
;   nmod=' MODIS (per agricultural region)'  
;  nmod='MODIS'
;  nmod='CARAIB'  
;nmod=' (Winter barley)'
 nmod=''
 
; filext_vec = name of file extension ('.dat' or '.res')

  filext_vec = ['.res','.res','.res','.res','.res','.res','.res','.res','.res','.res','.res','.res','.res','.res','.res','.res','.res','.res','.res','.res']  
;  filext_vec = ['.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat','.dat']  
  
; dirps = directory of output eps file 
dirps = '../ps/Belgium/MAR/CRU/plots/' 
  
; fileco : ecotxt file
fileco='/raid3/umccb/clim0017/stughilain/caraib/clim/Belgium/MAR/ecotxt.dat'

; iarea: read (yes/no) pixel area (in m2) in fileco
;   iarea=0 (no)
;   iarea=1 (yes)
iarea=0
  
; nherb = number of herb pft/species
; nbush = number of shrub pft/species
; ntree = number of tree pft/species
; ncult = number of crop types
; npast = number of pasture pft/species


;; PFTs or species
  nherb = 3
  nbush = 8
  ntree = 15
  ncult = 0
  npast = 0


  npft0 = nherb+nbush+ntree
  npft = npft0+ncult+npast
  
; ispat_mean : average over spatial domain
;   ispat_mean = 0 --- no spatial average (pixel plot)
;   ispat_mean = 1 --- spatial average over lat-long rectangular window
;   ispat_mean = 2 --- spatial average over regions defined in a file 
ispat_mean=1


; location= site name (e.g., village name, forest name, etc)
;  location='Wallonia'
  location='Belgium'
 
; reslat, reslong = latitude, longitude resolution of the grid (deg)
; In the case of irregular grids, reslat and reslong must contain the maximum error (or precision)
; acceptable on respectively latitude and longitude values. In this case, the areas of the pixels must be
; provided in fileco (ecotxt file)     
;  reslat = 0.008333
;  reslong = 0.008333
  reslat = 0.1000000
  reslong = 0.0666666  

; yr0 = first year in plot
; yrc = year of change of directory for input files
; yrf = last year in plot
  yr0 = 1992
  yrc = 2100
  yrf = 2010    

; itime = time resolution of inputs
; yearly: itime = 0 
; monthly: itime = 1
; daily: itime = 2
;  itime=2     ;(climate)
  itime=1      ; caraib results
  
; ileap = to take leap year into account
;          ileap = 1 leap years (nd = 365 or 366)
;          ileap = 0 leap years not possible (nd=365)
ileap = 1
  
; imean = annual mean or sum
; plot annual cumulative value   imean = -1
; plot every time step (no mean) imean = 0
; plot annual mean               imean = 1
  imean = 0

; imean_sp = mean or cumulative value over pixels 
; plot cumulate over pixels   imean_sp = -1
; plot average over pixels    imean_sp =  1
  imean_sp = 1  


; filvar1 = name of variable (in filename string)
;  filvar1 = 'tem'
;  filvar1 = 'Tmmin'
;  filvar1 = 'Tdmin'  
;  filvar1 = 'prc'
;  filvar1 = 'rhu'
;  filvar1 = 'fsol'
;  filvar1 = 'dte' 
;  filvar1 = 'wnd' 
;   filvar1='sw'
;   filvar1 = 'prc'
;   filvar1 = 'gppmth'
;   filvar1 = 'GPP'
;    filvar1 = 'ramth'
;   filvar1 = 'rhmth'
;   filvar1 = 'laimth'
;   filvar1 = 'LAIMODIS_'
   filvar1 = 'nppmth'
;   filvar1 = 'nepmth'
;   filvar1 = 'nbpmth'
;   filvar1 = 'biommth'
;   filvar1 = 'harvmth' 
;    filvar1 = 'emifiremth'
;    filvar1 = 'npp'
;    filvar1 = 'gpp' 
;   filvar1 = 'laimoy'
;   filvar1 = 'biommth'
;    filvar1 = 'frcC13'
;     filvar1 = 'ftot'
;  filvar1 = 'Cveg'
;  filvar1 = 'frac'
;  filvar1 = 'Csoil'
;  filvar1 = 'aburn'
;   filvar1 = 'lucflx'
;   filvar1 = 'yield'
;   filvar1 = 'frac'
;   filvar1 = 'ftot'
;    filvar1='multi'
;    filvar_vec=['gppmth','nppmth','ramth','rhmth']
;    filvar_vec=['nepmth','nbpmth']    
;    filvar_vec=['nppmth','rhmth']
;    filvar_vec=['tem','tem','tem','tem','tem','tem','tem','tem','tem','tem']
;    filvar_vec=['rhu','rhu','rhu','rhu','rhu','rhu','rhu','rhu','rhu','rhu']
;    filvar_vec=['prc','prc','prc','prc','prc','prc','prc','prc','prc','prc']
;    filvar_vec=['fsol','fsol','fsol','fsol','fsol','fsol','fsol','fsol','fsol','fsol']    
;    filvar_vec=['dte','dte','dte','dte','dte','dte','dte','dte','dte','dte']
;    filvar_vec=['wnd','wnd','wnd','wnd','wnd','wnd','wnd','wnd','wnd','wnd'] 


; ylab = label for y axis on plot
;  ylab = 'Soil Water Content (SW-WP)/(FC-WP)'
;   ylab = 'Annual Mean Air Temperature (!eo!nC)'
;   ylab = 'Air Temperature (!eo!nC)'
;   ylab = 'Yearly Minimum Daily Air Temperature (!eo!nC)'
;   ylab = 'Air Relative Humidity (%)'
;   ylab = 'Surface Solar Radiation Flux (W m!e-2!n)'
;   ylab = 'Daily Temperature Amplitude(!eo!nC)'
;   ylab = 'Surface Wind Speed (m s!e-1!n)'
;   ylab = 'Mean Night Temperature of the Coldest Month (!eo!nC)'
;   ylab = 'Annual Precipitation (mm/year)'
;   ylab = 'Annual Mean Surface Solar Radiation Flux (W m!e-2!n)'
;   ylab = 'Precipitation (mm/month)'
;   ylab = 'Precipitation (mm/day)'
;   ylab = 'Species Net Primary Productivity (g C m!e-2!n yr!e-1!n)'
;   ylab = 'Species 13C Fractionation (per mil)'
;   ylab = 'Net Primary Productivity (g C m!e-2!n yr!e-1!n)'
;   ylab = 'Average Carbon fluxes (g C m!e-2!n yr!e-1!n)'
   ylab = 'Net Primary Productivity (g C m!e-2!n mo!e-1!n)'
;   ylab = 'Net Primary Productivity (g C m!e-2!n day!e-1!n)'
;   ylab = 'Net Ecosystem Productivity (g C m!e-2!n yr!e-1!n)'
;   ylab = 'Net Ecosystem Productivity (g C m!e-2!n mo!e-1!n)'
;   ylab = 'Net Ecosystem Productivity (g C m!e-2!n day!e-1!n)'   
;   ylab = 'Leaf Area Index (m!e2!n m!e-2!n)'
;    ylab = 'Gross Primary Productivity (g C m!e-2!n yr!e-1!n)'
;    ylab = 'Gross Primary Productivity (g C m!e-2!n day!e-1!n)'
;    ylab = 'Relative survival rate'  
; ylab = 'Gross Primary Productivity (Pg C yr!e-1!n)
; ylab = 'Gross Primary Productivity (Mt C yr!e-1!n)'
; ylab = 'Global Carbon Fluxes (Pg C yr!e-1!n)'
;   ylab = 'Carbon Fluxes (Mt C yr!e-1!n)'
;   ylab = 'Net Primary Productivity (Mt C yr!e-1!n)'
; ylab = 'Cumulated Carbon Fluxes (Mt C yr!e-1!n)'
;  ylab = 'Autotrophic Respiration (Pg C yr!e-1!n)'
;  ylab = 'Autotrophic Respiration (Mt C yr!e-1!n)'
;    ylab = 'Heterotrophic Respiration (Pg C yr!e-1!n)'
;    ylab = 'Heterotrophic Respiration (Mt C yr!e-1!n)'
; ylab = 'Net Primary Productivity (Pg C yr!e-1!n)'
; ylab = 'Net Primary Productivity (Mt C yr!e-1!n)'
; ylab = 'Net Ecosystem Productivity (Pg C yr!e-1!n)'
; ylab = 'Net Biosphere-Atmosphere Flux (Pg C yr!e-1!n)'
; ylab = 'Net Biome Productivity (Pg C yr!e-1!n)'
; ylab = 'Net Biome Productivity (Mt C yr!e-1!n)' 
; ylab = 'Net Ecosystem Productivity (Mt C yr!e-1!n)' 
;  ylab = 'Net Ecosystem Productivity (Pg C mo!e-1!n)'
; ylab = 'Crop Harvested Biomass (Pg C yr!e-1!n)'
; ylab = 'Crop Harvested Biomass (Mt C yr!e-1!n)'
;  ylab = 'Fire emission (Pg C yr!e-1!n)'
;ylab = 'Aboveground Biomass (Mg C ha!e-1!n)'
;ylab = 'Aboveground Biomass (Pg C)'
; ylab = 'Biomass (Pg C)'
; ylab = 'Biomass (Mt C)'
;  ylab = 'Biomass of broadleaf trees (Mt C)'
;  ylab = 'Biomass of needleleaf trees (Mt C)'
;  ylab = 'Biomass of all trees (Mt C)'
;  ylab = 'Biomass of forests and trees (Mt C)'
;  ylab = 'Biomass of crops (Mt C)'
;  ylab = 'Biomass of pastures (Mt C)'
;  ylab = 'Total biomass of vegetation (Mt C)'    
;  ylab = 'Broadleaf tree biomass (kg C m!e-2!n)'
;  ylab = 'Needleleaf tree biomass (kg C m!e-2!n)'
;  ylab = 'Average tree biomass (kg C m!e-2!n)'      
; ylab = 'Soil Organic Carbon (Pg C)'
;  ylab = 'Total Soil Carbon (Pg C)'
;  ylab = 'Total Soil Carbon (Mt C)'
;   ylab = 'Mean Leaf Area Index (m!e2!n m!e-2!n)'
; ylab = 'Species cover fraction (g C m!e-2!n)'
;ylab = 'Biomass (g C m!e-2!n)'
;ylab = 'Biomass (kg C m!e-2!n)'
;ylab = 'Burned area (10!e6!n km!e2!n)'
;ylab = 'Yield (t/ha)'
;ylab = 'Area (km!e2!n)'
;  ylab = 'Area of forests and trees (km!e2!n)'
;ylab = 'Area of needleleaf trees (km!e2!n)'
;ylab = 'Area of broadleaf trees (km!e2!n)'
;  ylab = 'Area of forests and trees (ha)'  
;  ylab = 'Fraction of forests and trees'
;  ylab = 'Area of crops (km!e2!n)'
;  ylab = 'Area of pastures (km!e2!n)'
;  ylab = 'Total Area of vegetation (km!e2!n)'
;ylab = 'Total mortality coefficient'
; ylab = 'Carbon emission from land use change (Gt C yr!e-1!n)
; ylab = 'Litter production from land use change (Gt C yr!e-1!n)


; fac_units = unit conversion factor for the variable or its cumulative value
;fac_units = 10.7/1000.
fac_units = 1.
;fac_units = 1./1000.
;fac_units = 0.82/100.
;fac_units = 0.82/1.e+15  
;fac_units = 1./1.e+15
;fac_units = 12./1.e+15
;fac_units = 1./1.e+6
;fac_units = 1./1.e+4
;fac_units = 1./1.e+12


name_var=''
  
; filtyp = type of file 
; - single variable file (tem, dte,gppmth,nppmth, etc): filtyp = 0
; - species file (gpp, npp, etc): filtyp = 1
; - several variable file (water_yr, Csoil):filtyp = 2
  filtyp = 0
  
  if filtyp eq 1 then begin
    itime = 0
;   ipft = plant type number to be plotted
;   name_pft = name of plant type to be plotted
;   iwfrac = controls weighting by pft/species fraction - iwfrac=0 not weighted / iwfrac=1 average weighted by fraction
;     ipft_v = [1,2]
;     ipft_v = [-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1]
;     ipft_v = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]     
;     ipft_v = [-1,4,5,6,7,8,9,13,15,16]
;     ipft_v = [4,5,6,7,8,9,13,15,16]     
     ipft_v = [-1,3,10,11,12,14]
;     ipft_v = [3,10,11,12,14]
;     ipft_v = [17,18,19,20,27,28]
;      ipft_v = [21,22,23,24,25,26]
;      ipft_v = [-1,29]

     file_pft ='/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/plantparam/species_tol_t6.dat'
      iwfrac=1 
      
     ipft_sum = [3,10,11,12,14] 
;     title_pft = 'Total area of needleleaf trees'     
;     title_pft = 'Total for needleleaf trees'
     title_pft = 'Average for needleleaf trees' 
         
;     ipft_sum = [4,5,6,7,8,9,13,15,16] 
;      title_pft = 'Total area of broadleaf trees'     
;     title_pft = 'Total for broadleaf trees'
;     title_pft = 'Average for broadleaf trees'
     
;     ipft_sum = [1,2,17,18,19,20,27,28,21,22,23,24,25,26,29] 
;     title_pft = 'Total biomass of non tree species'

;     ipft_sum = [3,10,11,12,14,4,5,6,7,8,9,13,15,16]
;     title_pft = 'Total for all trees'

;     ipft_sum = [17,18]
;     title_pft = 'Mean for winter barley'

;     ipft_sum = [3,10,11,12,14,4,5,6,7,8,9,13,15,16]      ;area
;     ipft_sum = [1,2,3,10,11,12,14,4,5,6,7,8,9,13,15,16]      ;biomass, npp
;     title_pft = 'Total for forests and trees'
     
;     ipft_sum = [17,18,19,20,27,28,21,22,23,24,25,26]
;     title_pft = 'Total for all crops'

;     ipft_sum = [29]
;     title_pft = 'Total for pastures'   

;     ipft_sum = [3,10,11,12,14,4,5,6,7,8,9,13,15,16,17,18,19,20,27,28,21,22,23,24,25,26,29]    ;area
;     ipft_sum = [1,2,3,10,11,12,14,4,5,6,7,8,9,13,15,16,17,18,19,20,27,28,21,22,23,24,25,26,29] ;biomass,npp
;     title_pft = 'Total for all vegetation'       
      
;      title_pft=legend_sim_v(isim-1)   if itpft=1
      itpft=1
; name to be added to eps filename when multigraph = 0 (all simulations on same graphics) and ifyltyp = 1      
;      name_graph='_broadleaf_trees_mean'
;      name_graph='_broadleaf_trees'       
      name_graph='_needleleaf_trees_mean'
;      name_graph='_needleleaf_trees'
;      name_graph='_all_trees_pix'
;      name_graph='_forests_and_trees'
;      name_graph='_forests_and_trees_mean'       
;      name_graph='_mean_all_crops_regmean'
;      name_graph='_all_pastures'
;      name_graph='_all_vegetation_regmean'                     
  endif
  
  if filtyp eq 2 then begin
    itime = 0
;   ivar = variable number to be plotted
;   name_var = name of variable to be plotted
;   nvar = number of variables in file (water_yr=13)
;   igg = 1 or 0 depending on the format of the inputs:
;           0: long, lat, ...
;           1: ig, long, lat, ...
    ivar = 1
    name_var = '_TotCsoil'
    nvar = 5
    igg = 0
  endif
  
; ineg : to change the sign of the variable to be plotted
; ineg = 0  plot variable as it it
; ineg = 1  changes the sign of the variable 
ineg = 0


; xps = width of eps window
; yps = height of eps window
xps=40
;yps=15
yps=30

; overplot running mean (smoothing) of the variable
; i_smth = 0 (no running mean)
; i_smth = 1 (overplot running mean)
; n_smth = number of points over which the running mean is performed
i_smth = 0
n_smth = 11

; detrending of data using linear fit 
; i_detr = 0  (no detrending) 
; i_detr = 1  (detrending using linear fit)
i_detr = 0
   
; ================== END OF USER-DEFINED PARAMETERS =======================

file_mkdir,dirps 

if nsim gt 1 then i_smth = 0

if (imean_sp ne -1) and (imean_sp ne 1) then begin
    print,'imean_sp must be equal to 1 or -1'
    print,'Program stop'
    stop
endif


isim0=1
for isim = isim0, nsim do begin
  num_mv = 0.
  if filtyp eq 1 then begin
    if (itpft eq 1) then title_pft=legend_sim_v(isim-1)
  endif
      
; fildir = name of directory where files should be read for year < yrc
  fildir = genpath+dirmod(isim-1)+diract(isim-1)



; fildirc = name of directory where files should be read for year >= yrc
if yrf ge yrc then fildirc = genpath+dirmod(isim-1)+dirfut(isim-1)

 if filvar1 eq 'multi' then filvar = filvar_vec(isim-1) else filvar = filvar1
 if filvar1 eq 'multi' then filvarp = 'multi'+filvar_vec(isim0-1) else filvarp = filvar1
 
 if filtyp eq 1 then begin
  ipft = ipft_v(isim-1)
  if ipft ge -1 and ipft le npft then begin
   if ipft ge 1 then begin
    close,4
    openr,4,file_pft
    nothing = ''
    name_pft = ''
    name_pft_v = strarr(npft)
    readf,4,nothing
    for jp = 0, npft-1 do begin
     readf,4,name_pft,format='(a50)'
     name_pft_v(jp)=name_pft
    endfor
    close,4
    name_pft=strtrim(name_pft_v(ipft-1),2)
   endif else begin
    name_pft = title_pft
    sizeps=size(ipft_sum)
    nps=sizeps(1)
    if nps le 0 then begin
     print,'ERROR - ipft_sum not correctly defined. It should be defined as a one-dimension vector of at lest one component: '
     print,'PROGRAM STOP'
     stop    
    endif    
   endelse
  endif else begin
   print,'ERROR - wrong value of ipft in vector ipft_v: ',ipft
   print,'PROGRAM STOP'
   stop 
  endelse
  legend_sim=name_pft  
 endif else begin
  legend_sim=legend_sim_v(isim-1)
 endelse
 
 print,'Simulation ',isim,' : ',legend_sim
 
 if ispat_mean eq 0 then begin
  lat_pix  = lt_pix(isim-1)
  long_pix = lg_pix(isim-1) 
 endif 
 if ispat_mean eq 1 then begin  
  lat_min  = lt_min(isim-1)
  lat_max  = lt_max(isim-1)
  long_min = lg_min(isim-1)
  long_max = lg_max(isim-1) 
 endif
 if ispat_mean eq 2 then begin
  close,3
  openr,3,filereg
 endif
 if ispat_mean lt 0 or ispat_mean ge 3 then begin
  print,'ispat_mean out of range: ',ispat_mean
  print,'Choose one of the following values: 0, 1 or 2'
  print,'Program stop'
  stop
 endif 
 
 nyr = yrf-yr0+1
 nm = 12


 print,yr0,yrf,nyr

 ndyr= fltarr(nyr)
 ndays = long(0)
 for iyr = yr0, yrf do begin
  if ileap eq 0 then begin
        nd = 365
        ndyr(iyr-yr0) = nd
  endif else begin
        r100 = iyr mod 100
        if r100 eq 0 then begin
         icentury = iyr/100
	 r4 = icentury mod 4
        endif else begin    
         r4 = iyr mod 4
        endelse 
        if r4 eq 0 then nd=366 else nd = 365 
	ndyr(iyr-yr0) = nd
  endelse 
  ndays = ndays + nd 
 endfor 


 if itime eq 0 then begin
  ntime = long(nyr)
  nv = 1
 endif
 if itime eq 1 then begin 
  ntime = long(nyr)*long(nm)
  nv = nm
  if imean ne 0 then ntime = long(nyr)
 endif
 if itime eq 2 then begin 
  ntime = long(ndays)
  if imean ne 0 then ntime = long(nyr)
 endif

 icount=lonarr(npix)

 time=fltarr(ntime)
 var_ig=fltarr(ntime,npix)
 var_ig(*,*)=0.
 area_pix=fltarr(npix)
 area_gl = 0.

 itim = long(0)
 if filtyp eq 1 then begin 
   vec1=fltarr(npft)
   frac=fltarr(npft)
 endif
 if filtyp eq 2 then vec2=fltarr(nvar)

 year0=string(yr0,format='(i4)')
 yearf=string(yrf,format='(i4)')


 for iyr = yr0, yrf do begin
  year=string(iyr,format='(i4)')
  filext=filext_vec(isim-1)
  if iyr lt yrc then filename=fildir+filvar+extact(isim-1)+year+filext else filename=fildirc+filvar+extfut(isim-1)+year+filext
  close,1
  openr,1,filename
  nd = ndyr(iyr-yr0)
  if itime eq 2 then nv = nd
  if filtyp eq 0 then vec=fltarr(nv) 
  print,year,nd

  if (filtyp eq 1) and (iwfrac eq 1) then begin
   if iyr lt yrc then filefrac=fildir+'frac'+extact(isim-1)+year+'.res' else filefrac=fildirc+'frac'+extfut(isim-1)+year+'.res'
   close,8
   openr,8,filefrac
  endif
 
  if imean ne 0 then begin
        time(itim) = iyr
  endif else begin
 	for k=1,nv do begin
	   time(itim+k-1) = iyr + (float(k)-0.5)/float(nv)
	endfor
  endelse
 
  close,2
  if iyr eq yr0 then openr,2,fileco
  
  area_pft =0.
   
  for ig = long(0), long(npix)-long(1) do begin
   if filtyp eq 0 then begin
     readf,1,a1,a2,vec
     if imv eq 1 then begin 
        nvc=size(vec)
	for ivc=0,nvc(1)-1 do begin
	  if abs(vec(ivc)-mis_val) le err_mv then begin
	    num_mv = num_mv+1
	    vec(ivc)=rep_val
	  endif
	endfor
     endif 
   endif
   if filtyp eq 1 then begin
     readf,1,a1,a2,vec1
     if iwfrac eq 1 then readf,8,frlg,frlt,frac
     if imv eq 1 then begin 
        nvc=size(vec1)
	for ivc=0,nvc(1)-1 do begin
	  if abs(vec1(ivc)-mis_val) le err_mv then begin
	    num_mv = num_mv+1
	    vec1(ivc)=rep_val
	  endif
	endfor
     endif          
   endif
   if filtyp eq 2 then begin
    if igg eq 1 then readf,1,iii,a1,a2,vec2 else readf,1,a1,a2,vec2
    if imv eq 1 then begin 
        nvc=size(vec2)
	for ivc=0,nvc(1)-1 do begin
	  if abs(vec2(ivc)-mis_val) le err_mv then begin
	    num_mv = num_mv+1
	    vec2(ivc)=rep_val
	  endif
	endfor
    endif    
   endif
   
     
   if iyr eq yr0 then begin
     if iarea eq 0 then begin
      readf,2,iii,ecolg,ecolt,isu,clay,silt,sand,elv,scol,fland
      area_pix(ig)=1.23604306d+10*reslat*reslong*cos(ecolt*3.14159265/180.)*fland
     endif else begin
      readf,2,iii,ecolg,ecolt,isu,clay,silt,sand,elv,scol,fland,parea
      area_pix(ig)=fland*parea
;      print,'Pixel area: ',ig,area_pix(ig)
     endelse      
     if (abs(ecolg-a1) ge (0.50*reslong)) or (abs(ecolt-a2) ge (0.50*reslat)) then begin
      print,'Pixels not in same order (or incorrect long/lat) in ecotxt file' 
      print,'and the file defining the variable to be plotted',fileco
      print,'pixel number:',ig-1,iii
      print,'ecolg, a1: ',ecolg,a1
      print,'dif long: ',abs(ecolg-a1),'   half long resol: ',0.50*reslong
      print,'ecolt, a2: ',ecolt,a2      
      print,'dif lat:  ',abs(ecolt-a2),'   half lat  resol: ',0.50*reslat
      stop
     endif     
     icount(ig) = 0
     if ispat_mean eq 0 then begin 
      dif_long = abs((a1-long_pix)/reslong)
      if dif_long le 0.500001 then begin
       dif_lat = abs((a2-lat_pix)/reslat)
       if dif_lat le 0.500001 then begin
        icount(ig) = 1
	print,'ig:',ig,iii,'  Long:',ecolg,'  Lat:',ecolt
       endif
      endif 
     endif
     if ispat_mean eq 1 then begin
      if (long_min le a1) and (a1 le long_max) then begin
       if (lat_min le a2) and (a2 le lat_max) then begin
        icount(ig) = 1      
       endif
      endif
     endif
     if ispat_mean eq 2 then begin
      readf,3,iii,reglg,reglt,parea,kreg
      if (abs(reglg-a1) ge (0.5*reslong)) or (abs(reglt-a2) ge (0.5*reslat)) then begin
        print,'Pixels not in correct order or incorrect longitudes/latitudes in the file defining regions',filereg
        print,'pixel number:',iii
        stop
      endif
      if kreg eq ireg(isim-1) then icount(ig) = 1
     endif
     if icount(ig) eq 1 then area_gl = area_gl+area_pix(ig)
   endif
   
   if icount(ig) eq 1 then begin 
        if filtyp eq 0 then begin
	 if imean eq -1 then begin
	   var_ig(itim,ig) = 0.
	   for k=1,nv do begin
	     var_ig(itim,ig) = var_ig(itim,ig)+vec(k-1)
	   endfor
	 endif
	 if imean eq 0 then begin  
	   for k=1,nv do begin
	    var_ig(itim+k-1,ig) = vec(k-1)
	   endfor
	 endif
	 if imean eq 1 then begin
	   var_ig(itim,ig) = 0.
	   for k=1,nv do begin
	     var_ig(itim,ig) = var_ig(itim,ig)+vec(k-1)/float(nv)
	   endfor
	 endif	 
	endif
        if filtyp eq 1 then begin 
	   if ipft ge 1 then begin
	     if iwfrac eq 1 then frcfac=frac(ipft-1) else frcfac = 1.	   
	     var_ig(itim,ig) = frcfac*vec1(ipft-1) 
	     area_pft = area_pft + frac(ipft-1)*area_pix(ig)
	   endif else begin  
	    var_ig(itim,ig)=0.
	    sfrac=0.
	    for jp = 0,nps-1 do begin
	     jpft=ipft_sum(jp)
	     if iwfrac eq 1 then frcfac=frac(jpft-1) else frcfac = 1.	    
	     var_ig(itim,ig)=var_ig(itim,ig)+frcfac*vec1(jpft-1)
	     sfrac=sfrac+frcfac
	     area_pft = area_pft + frac(jpft-1)*area_pix(ig)
	    endfor
	    if ipft eq 0 then begin 
              if sfrac ge 1.e-5 then begin 
	        var_ig(itim,ig)=var_ig(itim,ig)/sfrac
	      endif else begin
	        var_ig(itim,ig)=0.
	      endelse
	    endif 
	   endelse
        endif
        if filtyp eq 2 then begin 
	  var_ig(itim,ig) = vec2(ivar-1)
        endif
   endif

  endfor
  
  nextyear:
  if imean ne 0 then itim = itim + long(1) else itim = itim+long(nv) 
 endfor
 close,1,8

 var=fltarr(ntime)
 var(*)=0.

 if area_gl le 1.e-5 then begin
  print,'No pixel found in search area'
  print,'Program stop'
  stop
 endif
 
 if imean_sp eq -1 then begin 
   facmul = fac_units 
 endif else begin 
  if (iwfrac eq 1) and (filtyp eq 1) then begin 
     if area_pft gt 1.e-5 then facmul = fac_units/area_pft else facmul=0. 
  endif else begin
     facmul = fac_units/area_gl
  endelse 
 endelse
 
 ;print,'facmul=',facmul,'  area_pft=',area_pft,'   area_gl=',area_gl
 
 for itim = long(0), long(ntime)-long(1) do begin
  for ig = long(0), long(npix)-long(1) do begin
   if icount(ig) eq 1 then begin 
	var(itim) = var(itim)+var_ig(itim,ig)*facmul*area_pix(ig)
   endif  
  endfor
 endfor

 ;print,time

 if ispat_mean eq 0 then begin
  type=-1
  coord_label,lat_pix,type,lat_label
  type=1
  if long_pix gt 180. then long_pix = long_pix-360.
  if long_pix lt -180. then long_pix = long_pix+360.
  coord_label,long_pix,type,long_label
  regfiln=strcompress('_'+legend_sim_v(isim-1)+'_long'+string(fix(long_pix),format='(i4)')+'_lat'+string(fix(lat_pix),format='(i3)'),/remove_all)
 
 ; reglab = label for region (e.g.,lat,long)
  reglab = '   Long: '+long_label+'  Lat: '+lat_label
 endif else begin
  reglab=location
  regfiln=''
 endelse

 ; xlab = label for x axis on plot
   xlab = 'Year A.D.'
  
 if ineg eq 1 then var(*) = -var(*) 

  
 if isim eq isim0 then begin 
  if ifout eq 1 then begin
   close,55
   fileout=dirps+filvar+'_'+nmod+'_'+year0+'-'+yearf+location+regfiln+'.dat'
   openw,55,fileout 
  endif
 endif
  
 if multi_graph eq 0 then begin
  if isim eq isim0 then begin  
   fileps=dirps+filvarp+name_var+'_'+nmod+'_'+year0+'-'+yearf+location+regfiln+'.eps'
   title_lab = reglab+nmod
   if filtyp eq 1 then begin
      if multi_graph eq 1 then begin
        title_lab = reglab+nmod+'    '+name_pft
	fileps=dirps+filvarp+name_var+'_'+nmod+'_'+year0+'-'+yearf+location+regfiln+name_pft+'.eps'
      endif else begin
        title_lab = reglab+nmod
	fileps=dirps+filvarp+name_var+'_'+nmod+'_'+year0+'-'+yearf+location+regfiln+name_graph+'.eps'
      endelse
   endif   
   epsopen,file=fileps,/po,/psf,xs=xps,ys=yps
   device,/color

 
   ;plot,time,var,psym=psymc,/nodata
   ;plot,time,var,title=title_lab,xtitle=xlab,ytitle=ylab,/nodata
   if i_yrange eq 1 and i_xrange eq 1 then begin
    plot,time,var,title=title_lab,xtitle=xlab,ytitle=ylab,xrange=[xmin,xmax],yrange=[ymin,ymax],xstyle=1,ystyle=1,psym=psymc,/ynozero,/nodata,charsize=c_size
   endif else begin 
    if i_yrange eq 1 then begin   	
     plot,time,var,title=title_lab,xtitle=xlab,ytitle=ylab,yrange=[ymin,ymax],ystyle=1,psym=psymc,/ynozero,/nodata,charsize=c_size
    endif else begin
     if i_xrange eq 1 then begin   	
      plot,time,var,title=title_lab,xtitle=xlab,ytitle=ylab,xrange=[xmin,xmax],xstyle=1,psym=psymc,/ynozero,/nodata,charsize=c_size
     endif else begin  
      plot,time,var,title=title_lab,xtitle=xlab,ytitle=ylab,psym=psymc,/ynozero,/nodata,charsize=c_size
     endelse
    endelse
   endelse
  endif
 endif else begin
   epsclose
   fileps=dirps+'multi_'+filvar_vec(isim-1)+'_'+nmod+'_'+year0+'-'+yearf+location+regfiln+'.eps'
   if filtyp eq 1 then fileps=dirps+'multi_'+filvar_vec(isim-1)+'_'+nmod+'_'+year0+'-'+yearf+location+regfiln+name_pft+'.eps'
   epsopen,file=fileps,/po,/psf,xs=xps,ys=yps
   device,/color
   title_lab = reglab+nmod
   if filtyp eq 1 then title_lab = reglab+nmod+'    '+name_pft
   ;plot,time,var,psym=psymc,/nodata
   ;plot,time,var,title=title_lab,xtitle=xlab,ytitle=ylab,/nodata
   if i_yrange eq 1 and i_xrange eq 1 then begin
    plot,time,var,title=title_lab,xtitle=xlab,ytitle=ylab,xrange=[xmin,xmax],yrange=[ymin,ymax],psym=psymc,/ynozero,/nodata,charsize=c_size
   endif else begin 
    if i_yrange eq 1 then begin   	
     plot,time,var,title=title_lab,xtitle=xlab,ytitle=ylab,yrange=[ymin,ymax],psym=psymc,/ynozero,/nodata,charsize=c_size
    endif else begin
     if i_xrange eq 1 then begin   	
      plot,time,var,title=title_lab,xtitle=xlab,ytitle=ylab,xrange=[xmin,xmax],psym=psymc,/ynozero,/nodata,charsize=c_size
     endif else begin  
      plot,time,var,title=title_lab,xtitle=xlab,ytitle=ylab,psym=psymc,/ynozero,/nodata,charsize=c_size
     endelse
    endelse
   endelse       
 endelse 

 icol=color_sim(isim-1)
 xline= linest_sim(isim-1)
 
 if (i_detr eq 1) then begin 
   lin_coeff= linfit(time,var)
   var1=fltarr(ntime)
   for itim = long(0), long(ntime)-long(1) do var1(itim)=lin_coeff(0)+lin_coeff(1)*time(itim)
   dtr_var=var-var1
   oplot,time,dtr_var,psym=psymc,color=icol,line=xline,thick=lthk
 endif else begin
   oplot,time,var,psym=psymc,color=icol,line=xline,thick=lthk 
 endelse

 if nsim gt 1 then begin 
   midsim = fix((nsim+1)/2)
   if (i2column eq 1) and (isim ge (midsim+1)) then begin
       delxleg = (xmax-xmin)*0.50
       dsim = midsim
   endif else begin
       delxleg = 0.
       dsim = 0. 
   endelse 
   x1 = xleg+delxleg
   x2 = xleg+delxleg+dxleg
   x3 = xleg+delxleg+1.2*dxleg
   if (multi_graph eq 1) then y1 = yleg else y1 = yleg -(isim-dsim-1)*dyleg

   oplot,[x1,x2],[y1,y1],psym=psymc,color=icol,line=xline,thick=lthk
   xyouts,x3,y1,legend_sim,charsize=l_size 
 endif

 if i_smth eq 1 then begin
  nvalues=n_smth
  var_smth = ts_smooth(var,nvalues)
  oplot,time,var_smth,line=2,thick=lthk
 endif

; if ifout eq 1 then begin
;  printf,55,legend_sim
;  for ktime = long(0), long(ntime)-long(1) do printf,55,time(ktime),var(ktime),format='(1x,i7,1x,e12.5)'
; endif
 
 if ifout eq 1 then begin
  if ispat_mean eq 0 then begin
    printf,55,legend_sim,' at Long: ',lg_pix(isim-1),' Lat: ',lt_pix(isim-1)
  endif 
  if ispat_mean eq 1 then begin
    printf,55,legend_sim  ;,' at Long: ',lg_min(isim-1),' - ',lg_max(isim-1),' Lat: ',lt_min(isim-1),' - ',lt_max(isim-1)  
  endif
  if ispat_mean eq 2 then begin
    printf,55,legend_sim
  endif
  iday = fix(0)
  iyearp = fix(time(long(0)))
  for ktime = long(0), long(ntime)-long(1) do begin
   iyear = fix(time(ktime))
   if iyearp ne iyear then iday = 0
   iday = iday + 1
;   iday=1+fix((time(ktime)-iyear)*nd)   
   printf,55,time(ktime),iyear,iday,var(ktime),format='(f12.6,2(1x,i6),20(1x,f12.6))'
   iyearp = iyear
  endfor
 endif 
 
 if imv eq 1 then print,'Number of missing values in file: ',num_mv

endfor
close,55

zero=fltarr(ntime)
for i=long(0),long(ntime)-long(1) do zero(i)=0.
if filvar eq 'nepmth' or filvar eq 'nbpmth' then oplot,time,zero,line=1,thick=lthk

if idata eq 1 then begin
  close,75
  openr,75,filedata
  x_data = fltarr(ndata)
  y_data = fltarr(ndata)
  for k = 0, ndata-1 do begin
    readf,75,xx,yy
    x_data(k) = xx+0.5
    y_data(k) =yy
  endfor
  close,75  
  oplot,x_data,y_data,psym=psymd,color=0,line=0,thick=lthk

; legend
   midsim = fix((nsim+1)/2)
   if (i2column eq 1) then begin
       delxleg = (xmax-xmin)*0.50
       dsim = midsim
   endif else begin
       delxleg = 0.
       dsim = 0. 
   endelse 
   x1 = xleg+delxleg
   x2 = xleg+delxleg+dxleg
   x3 = xleg+delxleg+1.2*dxleg
   if (multi_graph eq 1) then y1 = yleg-dyleg else y1 = yleg -(nsim-dsim)*dyleg   

   oplot,[x1,x2],[y1,y1],psym=psymd,color=0,line=0,thick=lthk
   xyouts,x3,y1,legend_data,charsize=l_size
endif 

 
device,/close
	  
return
end




;***********************************
pro coord_label,c_pix,c_type,c_label
;***********************************

; This subroutine converts a decimal value of a longitude or latitude coordinate
; into a string containing the coordinate in degree, minutes and seconds
; INPUT: c_pix = decimal value of the coordinate 
;        c_type = negative if c_pix is latitude
;               = positive if c_pix is longitude
; OUTPUT: c_label = string with the coordinate in degree, minutes, seconds


if c_pix lt 0 then begin
  if c_type lt 0 then sector='S ' else sector='W '  
endif else begin
  if c_type lt 0 then sector='N ' else sector='E '
endelse

c_deg = fix(abs(c_pix))
c_min = fix(60.*(abs(c_pix)-c_deg))
c_sec = 60.*(60.*(abs(c_pix)-c_deg)-c_min)
c_label = string(c_deg,format='(i4)')+'!eo!n'+sector+string(c_min,format='(i2)')+"' "+string(c_sec,format='(i2)')+'" '

return
end


